# DO NOT EDIT this file by hand!
# It is generated from corresponding Open API schema.
# Visit `yaookctl/commands/generate/model.py` for further details.

# generated by datamodel-codegen:
#   filename:  <stdin>

from __future__ import annotations

from typing import List, Optional

from pydantic import BaseModel, Field


class ChK8sLbaas(BaseModel):
    agent_port: Optional[int] = 15203
    enabled: Optional[bool] = True
    shared_secret: Optional[str] = '...'
    version: Optional[str] = '0.4.2'


class Apiserver(BaseModel):
    frontend_port: Optional[int] = 8888


class ContinuousJoinKey(BaseModel):
    enabled: Optional[bool] = False
    env_path: Optional[str] = None
    vault_path: Optional[str] = None
    vault_token_script: Optional[str] = None


class GlobalMonitoring(BaseModel):
    enabled: Optional[bool] = False
    nodeport: Optional[int] = None
    nodeport_name: Optional[str] = None


class Kubelet(BaseModel):
    pod_limit: Optional[int] = None


class Dynamic(BaseModel):
    data_directory: Optional[str] = None
    enabled: Optional[bool] = False
    namespace: Optional[str] = None
    nodeplugin_toleration: Optional[str] = None
    storageclass_name: Optional[str] = None
    version: Optional[str] = None


class Static(BaseModel):
    data_directory: Optional[str] = None
    discovery_directory: Optional[str] = None
    enabled: Optional[bool] = False
    namespace: Optional[str] = None
    nodeplugin_toleration: Optional[str] = None
    storageclass_name: Optional[str] = None
    version: Optional[str] = None


class LocalStorage(BaseModel):
    dynamic: Optional[Dynamic] = None
    static: Optional[Static] = None


class Monitoring(BaseModel):
    enabled: Optional[bool] = False


class Network(BaseModel):
    calico_ip_autodetection_method: Optional[str] = None
    calico_ipipmode: Optional[str] = None
    calico_ipv6_autodetection_method: Optional[str] = None
    plugin: Optional[str] = 'calico'
    pod_subnet: Optional[str] = '10.244.0.0/16'
    service_subnet: Optional[str] = '10.96.0.0/12'


class Storage(BaseModel):
    cinder_enable_topology: Optional[bool] = None
    nodeplugin_toleration: Optional[bool] = False
    rook_enabled: Optional[bool] = False


class Kubernetes(BaseModel):
    apiserver: Optional[Apiserver] = None
    continuous_join_key: Optional[ContinuousJoinKey] = None
    global_monitoring: Optional[GlobalMonitoring] = None
    is_gpu_cluster: Optional[bool] = False
    kubelet: Optional[Kubelet] = None
    local_storage: Optional[LocalStorage] = None
    monitoring: Optional[Monitoring] = None
    network: Optional[Network] = None
    storage: Optional[Storage] = None
    version: Optional[str] = '1.22.11'
    virtualize_gpu: Optional[bool] = None


class Labels(BaseModel):
    managed_k8s_worker_0: Optional[List[str]] = Field(
        None, alias='managed-k8s-worker-0'
    )
    managed_k8s_worker_1: Optional[List[str]] = Field(
        None, alias='managed-k8s-worker-1'
    )
    managed_k8s_worker_2: Optional[List[str]] = Field(
        None, alias='managed-k8s-worker-2'
    )
    managed_k8s_worker_3: Optional[List[str]] = Field(
        None, alias='managed-k8s-worker-3'
    )
    managed_k8s_worker_4: Optional[List[str]] = Field(
        None, alias='managed-k8s-worker-4'
    )
    managed_k8s_worker_5: Optional[List[str]] = Field(
        None, alias='managed-k8s-worker-5'
    )


class Taints(BaseModel):
    managed_k8s_worker_0: Optional[List[str]] = Field(
        None, alias='managed-k8s-worker-0'
    )
    managed_k8s_worker_2: Optional[List[str]] = Field(
        None, alias='managed-k8s-worker-2'
    )
    managed_k8s_worker_4: Optional[List[str]] = Field(
        None, alias='managed-k8s-worker-4'
    )


class NodeScheduling(BaseModel):
    labels: Optional[Labels] = None
    scheduling_key_prefix: Optional[str] = 'scheduling.mk8s.cloudandheat.com'
    taints: Optional[Taints] = None


class TestNodes(BaseModel):
    managed_k8s_worker_1: Optional[str] = Field(None, alias='managed-k8s-worker-1')
    managed_k8s_worker_3: Optional[str] = Field(None, alias='managed-k8s-worker-3')
    managed_k8s_worker_5: Optional[str] = Field(None, alias='managed-k8s-worker-5')
    my_var_foo: Optional[str] = None


class Testing(BaseModel):
    test_nodes: Optional[TestNodes] = Field(None, alias='test-nodes')


class Spec(BaseModel):
    ch_k8s_lbaas: Optional[ChK8sLbaas] = Field(None, alias='ch-k8s-lbaas')
    kubernetes: Optional[Kubernetes] = None
    node_scheduling: Optional[NodeScheduling] = Field(None, alias='node-scheduling')
    testing: Optional[Testing] = None


class Status(BaseModel):
    dataSecretName: Optional[str] = None
    ready: Optional[bool] = None


class Metadata(BaseModel):
    name: Optional[str] = None
    namespace: Optional[str] = None


class YaookConfigTemplate(BaseModel):
    spec: Spec
    status: Optional[Status] = None
    metadata: Optional[Metadata] = None
